!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine mixlen
     &(lmhk,lpbl,hpbl,ct,u,v,t,the,q,c,q2,z,gm,gh,el)
!     ******************************************************************
!     *                                                                *
!     *                   level 2.5 mixing length                      *
!     *             Janjic, 2001, NCEP Office Note #436.               *
!     *                                                                *
!     ******************************************************************
      include "parmeta"
!-----------------------------------------------------------------------
      parameter
     &(lp1=lm+1,lm1=lm-1)
!-----------------------------------------------------------------------
      parameter
     &(elivw=2.72e6,cp=1004.6,elocp=elivw/cp
     &,pq0=379.90516,aq2=17.2693882,aq3=273.15,aq4=35.86,rhcr=0.90)
!-----------------------------------------------------------------------
      parameter
     &(epsq2=0.20,epsl=0.32,epsru=1.e-7,epsrs=1.e-7
     &,repsr1=1./(1.+epsru)
     &,alph=0.20,vkrm=.40,elfc=0.23*0.5
     &,el0min=1.,el0max=1000.)
!-----------------------------------------------------------------------
      parameter
!-----------------------------------------------------------------------
     &(g=9.806,beta=1./273.,btg=beta*g
     &,prt=1.0,gam1=0.2222222222222222222
     &,a1=0.659888514560862645,a2=0.6574209922667784586
     &,b1=11.87799326209552761,b2=7.226971804046074028
     &,c1=0.000830955950095854396)
!-----------------------------------------------------------------------
!un     &(g=9.8,beta=1./273.,btg=beta*g
!un     &,prt=1.0,gam1=0.2222222222222222222
!un     &,a1=0.3310949523016403346,a2=0.8273378704055731278
!un     &,b1=5.959709141429526024,b2=3.626088092074591135
!un     &,c1=-0.3330651924968952113)
!-----------------------------------------------------------------------
!my     &(g=9.8,beta=1./273.,btg=beta*g
!my     &,prt=0.8,gam1=0.2222222222222222222
!my     &,a1=0.9222222350809054114,a2=0.7350190142719400952
!my     &,b1=16.60000023145629741,b2=10.10000014082581951
!my     &,c1=0.0805318118080613468)
!--------------coefficients of the terms in the denominator-------------
      parameter
     &(adnm=18.*a1*a1*a2*(b2-3.*a2)*btg
     &,adnh= 9.*a1*a2*a2*(12.*a1+3.*b2)*btg*btg
     &,bdnm= 6.*a1*a1
     &,bdnh= 3.*a2*(7.*a1+b2)*btg
!--------------free term in the equilibrium equation for (l/q)**2-------
     &,aeqm= 3.*a1*a2*b1*(3.*a2+3.*b2*c1+18.*a1*c1-b2)*btg
     &     +18.*a1*a1*a2*(b2-3.*a2)*btg
     &,aeqh= 9.*a1*a2*a2*b1*btg*btg+9.*a1*a2*a2*(12.*a1+3.*b2)*btg*btg
!--------------forbidden turbulence area--------------------------------
     &,requ=-aeqh/aeqm,epsgh=1.e-9,epsgm=requ*epsgh
!--------------near isotropy for shear turbulence, ww/q2 lower limit----
     &,ubryl=(18.*requ*a1*a1*a2*b2*c1*btg+9.*a1*a2*a2*b2*btg*btg)
     &      /(requ*adnm+adnh)
     &,ubry=(1.+epsrs)*ubryl
     &,ubry3=3.*ubry
     &,aubm=54.*a1*a1*a2*b2*c1*btg -adnm*ubry3
     &,aubh=27.*a1*a2*a2*b2*btg*btg-adnh*ubry3
     &,bubm=18.*a1*a1*c1           -bdnm*ubry3
     &,bubh=(9.*a1*a2+3.*a2*b2)*btg-bdnh*ubry3
     &,cubr=1.                     -     ubry3,rcubr=1./cubr)
!-----------------------------------------------------------------------
      dimension
     & u     (lm),v     (lm)
     &,t     (lm),the   (lm),q     (lm),c     (lm),q2    (lm)
     &,z     (lp1)
      dimension
     & gm    (lm1),gh    (lm1),el    (lm1)
!-----------------------------------------------------------------------
      dimension
     & elm   (lm1),q1    (lm )
!***********************************************************************
      lmhm=lmhk-1
      lmhp=lmhk+1
!-----------------------------------------------------------------------
          do l=1,lmhk
      q1(l)=0.
          enddo
!-----------------------------------------------------------------------
          do l=1,lmhm
      rdz=2./(z(l)-z(l+2))
      gml=((u(l)-u(l+1))**2+(v(l)-v(l+1))**2)*rdz*rdz
      gm(l)=max(gml,epsgm)
!
      tem=(t(l)+t(l+1))*0.5
      thm=(the(l)+the(l+1))*0.5
!
      a=thm*0.608
      b=(elocp/tem-1.608)*thm
!
      ghl=((the(l)-the(l+1)+ct)*((q(l)+q(l+1))*(0.5*0.608)+1)
     &    +(q(l)-q(l+1))*a
     &    +(c(l)-c(l+1))*b)*rdz
!
          if(abs(ghl).le.epsgh)    ghl=epsgh
      gh(l)=ghl
          enddo
!--------------find maximum mixing lengths & the level of the pbl top---
      lpbl=lmhk
          do l=1,lmhm
      gml=gm(l)
      ghl=gh(l)
      if(ghl.ge.epsgh)then
        if(gml/ghl.le.requ)then
          elm(l)=epsl
          lpbl=l
        else
          aubr=(aubm*gml+aubh*ghl)*ghl
          bubr= bubm*gml+bubh*ghl
          qol2st=(-0.5*bubr+sqrt(bubr*bubr*0.25-aubr*cubr))*rcubr
          eloq2x=1./qol2st
          elm(l)=max(sqrt(eloq2x*q2(l)),epsl)
        endif
      else
        aden=(adnm*gml+adnh*ghl)*ghl
        bden= bdnm*gml+bdnh*ghl
        qol2un= -0.5*bden+sqrt(bden*bden*0.25-aden)
        eloq2x=1./(qol2un+epsru)  !  repsr1/qol2un
        elm(l)=max(sqrt(eloq2x*q2(l)),epsl)
      endif
          enddo
!-----------------------------------------------------------------------
      if(elm(lmhm).eq.epsl)lpbl=lmhk
!--------------the height of the pbl------------------------------------
      hpbl=z(lpbl)-z(lmhp)
!-----------------------------------------------------------------------
          do l=lpbl,lmhk
      q1(l)=sqrt(q2(l))
          enddo
!-----------------------------------------------------------------------
      szq=0.
      sq =0.
          do l=1,lmhm
      qdzl=(q1(l)+q1(l+1))*(z(l+1)-z(l+2))
      szq=(z(l+1)+z(l+2)-z(lmhp)-z(lmhp))*qdzl+szq
      sq=qdzl+sq
          enddo
!--------------computation of asymptotic l in blackadar formula---------
      el0=min(alph*szq*0.5/sq,el0max)
      el0=max(el0            ,el0min)
!--------------inside the pbl-------------------------------------------
          do l=1,lmhm
      vkrmz=(z(l+1)-z(lmhp))*vkrm
      el(l)=min(vkrmz/(vkrmz/el0+1.),elm(l))
          enddo
!--------------correction above the pbl top-----------------------------
      lpblm=max(lpbl-1,1)
          do l=1,lpblm
      el(l)=min((z(l)-z(l+2))*elfc,elm(l))
          enddo
!-----------------------------------------------------------------------
                             return
                             end
