!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine vdifh
     &(lmhk,dtq2,thz0,qz0,akhs,ct,cklq,the,q,c,akh,z)
!     ******************************************************************
!     *                                                                *
!     *             vertical diffusion of mass variables               *
!     *             Janjic, 2001, NCEP Office Note #436.               *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      include "parmeta"
!-----------------------------------------------------------------------
      parameter
     &(lp1=lm+1,lm1=lm-1)
!-----------------------------------------------------------------------
      dimension
     & the   (lm),q     (lm),c     (lm)
      dimension
     & akh   (lm1)
     &,z     (lp1)
      dimension
     & cm    (lm1),cr    (lm1),rst   (lm1),rsq   (lm1),rsc   (lm1)
     &,dtoz  (lm1),akct  (lm1)
!***********************************************************************
      lmhm=lmhk-1
      lmhp=lmhk+1
!-----------------------------------------------------------------------
      cthf=ct*0.5
          do l=1,lmhm
      dtoz(l)=dtq2/(z(l)-z(l+1))
      cr(l)=-dtoz(l)*akh(l)
      akct(l)=akh(l)*(z(l)-z(l+2))*cthf
          enddo
!
      cm(1)=dtoz(1)*akh(1)+1.
!
      rst(1)=-akct(1)*dtoz(1)+the(1)
      rsq(1)=q(1)
      rsc(1)=c(1)
!-----------------------------------------------------------------------
          do l=2,lmhm
      dtozl=dtoz(l)
      cf=-dtozl*akh(l-1)/cm(l-1)
      cm(l)=-cr(l-1)*cf+(akh(l-1)+akh(l))*dtozl+1.
      rst(l)=-rst(l-1)*cf+(akct(l-1)-akct(l))*dtozl+the(l)
      rsq(l)=-rsq(l-1)*cf+q(l)
      rsc(l)=-rsc(l-1)*cf+c(l)
          enddo
!-----------------------------------------------------------------------
      dtozs=dtq2/(z(lmhk)-z(lmhp))
      akhh=akh(lmhm)
!
      cf=-dtozs*akhh/cm(lmhm)
      akqs=akhs*cklq
!
      cmb=cr(lmhm)*cf
      cmtb=-cmb+(akhh+akhs)*dtozs+1.
      cmqb=-cmb+(akhh+akqs)*dtozs+1.
      cmcb=-cmb+(akhh     )*dtozs+1.
!
      rstb=-rst(lmhm)*cf+akct(lmhm)*dtozs
     &                  +the(lmhk)
      rsqb=-rsq(lmhm)*cf+q(lmhk)
      rscb=-rsc(lmhm)*cf+c(lmhk)
!-----------------------------------------------------------------------
      the(lmhk)=(dtozs*akhs*thz0+rstb)/cmtb
      q  (lmhk)=(dtozs*akqs*qz0 +rsqb)/cmqb
      c  (lmhk)=(               +rscb)/cmcb
!-----------------------------------------------------------------------
          do ivi=1,lmhm
      l=lmhk-ivi
      rcml=1./cm(l)
      the(l)=(-cr(l)*the(l+1)+rst(l))*rcml
      q  (l)=(-cr(l)*q  (l+1)+rsq(l))*rcml
      c  (l)=(-cr(l)*c  (l+1)+rsc(l))*rcml
          enddo
!-----------------------------------------------------------------------
                             return
                             end
