      SUBROUTINE COLLECT_LOC ( A, B ) 
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C   SUBROUTINE:  COLLECT     COLLECT UP DATA ON TASK 0
C   PRGRMMR: BLACK           ORG:  NP22      DATE: 01-01-10
C
C ABSTRACT:  COLLECTS UP DATA ON TASK 0
C
C PROGRAM HISTORY LOG:
C   01-01-10  BLACK - ORIGINATOR
C
C USAGE:  CALL COLLECT_LOC(A,B)
C
C   INPUT ARGUMENT LIST:
C     A - ARRAY TO BE COLLECTED FROM
C
C   OUTPUT ARGUMENT LIST:
C     B - RESULTS OF THE COLLECTION
C
C   INPUT FILES:  NONE
C
C   OUTPUT FILES:  NONE
C
C   SUBPROGRAMS CALLED:
C     UNIQUE:
C            MPI_SEND
C            MPI_RECV
C
C   EXIT STATES:
C     COND =   0 - NORMAL EXIT
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE : IBM SP
C
C$$$
C----------------------------------------------------------------------
      INCLUDE "parmeta.resout"
      include "mpif.h"
C----------------------------------------------------------------------
      INCLUDE "MPI_PARM.comm"
      PARAMETER(IM=IMO,JM=JMO)
C----------------------------------------------------------------------
      REAL A(IM,JSTA:JEND)
      REAL B(IM,JM) 
      REAL BUF(IM*JM)
      INTEGER STATUS(MPI_STATUS_SIZE)
      INTEGER I,J
      INTEGER IERR
C----------------------------------------------------------------------
C
      IF(MYPE.EQ.0)THEN
C
        DO J=JSTA,JEND
        DO I=1,IM
          B(I,J)=A(I,J)
        ENDDO
        ENDDO
C
C***  RECEIVE FROM EVERYONE ELSE
C
        DO II=1,NUM_PROCS-1
          KOUNT=IM*(JEND_ALL(II)-JSTA_ALL(II)+1)
          CALL MPI_RECV(BUF,KOUNT,MPI_REAL,II,
     1                  II,MPI_COMM_WORLD,STATUS,IERR)
          III=0
          DO J=JSTA_ALL(II),JEND_ALL(II)
          DO I=1,IM
            III=III+1
            B(I,J)=BUF(III)
          ENDDO
          ENDDO
        ENDDO
C
      ELSE
        III=0
        DO J=JSTA,JEND
        DO I=1,IM
          III=III+1
          BUF(III)=A(I,J)
        ENDDO
        ENDDO
C
        CALL MPI_SEND(BUF,III,MPI_REAL,0,MYPE,MPI_COMM_WORLD,IERR)
c
      ENDIF
C
      END               
