@PROCESS NOEXTCHK
        PROGRAM INTRST
C-----------------------------------------------------------------------
C  01-02-01 H CHUANG - MODIFIED PROGRAM TO TAKE CARE OF HORIZONTAL 
C                      INTERPOLATION AT THE BOUNDARIES WHEN INPUT 
C                      AND OUTPUT DOMAINS OVERLAP AT BDY
C  01-03-01 H CHUANG - MODIFIED FOR MPI
C  01-03-01 H CHUANG - MODIFIED FOR MPI
C  11-19-01 T BLACK  - CORRECTED WIND ROTATION
C  04-30-03 E ROGERS - CORRECTED CODE TO USE EARTH LAT/LON
C                      INSTEAD OF TRANSFORMED LAT/LON AT THE BOUNDARIES 
C                      WHEN INPUT AND OUTPUT DOMAINS OVERLAP AT BDY
C
C NOTE: OVERLAP CODE ONLY WORKS FOR CERTAIN FOR 8-km AND 4-km HAWAII AND
C       PUERTO RICO GRIDS. IT HAS NOT BEEN TESTED FOR ANY OTHER 
C       CONFIGURATION AND IT IS STRONGLY ADVISED TO MAKE SURE THE     
C       NESTED DOMAIN DOES NOT OVERLAP THE BOUNDARY OF THE INPUT ETA DOMAIN!!
C
C--------------------------------------------------------------------
      INCLUDE "parmeta.resin"
      INCLUDE "parmeta.resout"
      INCLUDE "griddef.in"
      INCLUDE "griddef.out"
      INCLUDE "parmsoil"
      INCLUDE "mpif.h"
      INCLUDE "MPI_PARM.comm"
C--------------------------------------------------------------------
                          P A R A M E T E R
     & (KB=2*IMO+JMO-3,LMOP=LMO+1)
C-----------------------------------------------------------------------
                             D I M E N S I O N
     & HLATI(IMI,JMI),HLONI(IMI,JMI),VLATI(IMI,JMI),VLONI(IMI,JMI)
     &,ULOUT(2*LMO)
     &,DUM2DIN(IMI,JMI),DUM2DOUT(IMO,JMO),ZSFCO(IMO,JMO)
     &,IDUM2DOUT(IMO,JMO)
C-----------------------------------------------------------------------
C
      REAL,ALLOCATABLE,DIMENSION(:,:,:)::UI,VI,TI,QI,Q2I,CLDLIN
      REAL,ALLOCATABLE,DIMENSION(:,:,:)::TO,QO,UO,VO,CWMO,Q2O      
      REAL,ALLOCATABLE,DIMENSION(:,:,:)::DUM3DO,HTMO,VTMO
      INTEGER,ALLOCATABLE,DIMENSION(:,:)::LMHO,LMVO
C-----------------------------------------------------------------------
                             L O G I C A L
     & COMPWT,RUN,FIRST,SIGMA, NUSNOSST, LUSAF,HF
C-----------------------------------------------------------------------
                             C H A R A C T E R
     & LABEL*32
C-----------------------------------------------------------------------
                             C O M M O N  /SFCFLDS/
     & SST(IMO,JMO),ALBEDO(IMO,JMO),SI(IMO,JMO),SNO(IMO,JMO)
     &,SMC(IMO,JMO,NSOIL),STC(IMO,JMO,NSOIL),CMC(IMO,JMO)
C-----------------------------------------------------------------------
      COMMON /NEWSFCFLDS/ SH2O(IMO,JMO,NSOIL)
C-----------------------------------------------------------------------
                             C O M M O N /ROTATE/
     & ALPHA_OUT(IMO,JMO),ALPHA_IN(IMO,JMO)
C-----------------------------------------------------------------------
                             C O M M O N /LATLONS/
     & HLATO(IMO,JMO),HLONO(IMO,JMO),VLATO(IMO,JMO),VLONO(IMO,JMO)
     &,IHINX(IMO,JMO),IHINY(IMO,JMO),IVINX(IMO,JMO),IVINY(IMO,JMO)
     &,IH2HX(IMO,JMO),IH2HY(IMO,JMO),WH(IMO,JMO,4),WV(IMO,JMO,4)
C--------------------------------------------------------------------
                             C O M M O N /OUTETA/
     & PDO(IMO,JMO),PDB(KB,2)
     &,TB (KB,LMO,2),QB (KB,LMO,2),UB (KB,LMO,2),VB (KB,LMO,2)
     &,PT,DETAO(LMO),AETAO(LMO),ETAO(LMOP),DFLO(LMOP),SM(IMO,JMO)
     &,RESO(IMO,JMO),FISO(IMO,JMO)
C-----------------------------------------------------------------------
                             C O M M O N /MSKIN/
     & HTMI(IMI,JMI,LMI),VTMI(IMI,JMI,LMI),LMHI(IMI,JMI)
     &,LMVI(IMI,JMI)
C-----------------------------------------------------------------------
      COMMON /TGRND/ TG(IMO,JMO)
C--------------------------------------------------------------------
                             C O M M O N /DAT/
     & IDAT(3)
C--------------------------------------------------------------------
                             N A M E L I S T /MODTOP/
     & ETOP
C-----------------------------------------------------------------------
                             D I M E N S I O N
     & SLDPTH(NSOIL),RTDPTH(NSOIL)
C-----------------------------------------------------------------------
C----------------------  HORIZONTAL GRID CONSTANTS ---------------------
C-----------------------------------------------------------------------
       REAL(8) DELTA(4),PHI1,LAM1,COSPH1,SINPH1,PHI2,LAM2,SINPH2
     &,        COSPH2,COSDIF,T1,T2,GAR
C-----------------------------------------------------------------------
                             N A M E L I S T /ECONDATA/
     & TLM0D,TPH0D,WBD,SBD,DLMD,DPHD
     &,DT,W,IDTAD,IDTCF,COAC,CODAMP,TDDAMP,DFC,DDFC,SIGMA,NUSNOSST,LUSAF
     &,SLDPTH,RTDPTH
C-----------------------------------------------------------------------
      INCLUDE "TEMPRES"
C-----------------------------------------------------------------------
C***********************************************************************
C-----------------------------------------------------------------------
C***
C*** INITIALIZE MPI 
C***
      CALL MPI_FIRST
      print*,'mype,jsta,jend=',mype,jsta,jend
C
      IF(MYPE.EQ.(NUM_PROCS-1))THEN
        CALL START()
      ENDIF
C-----------------------------------------------------------------------
C***
C***  READ IN ETOP VIA NAMELIST
C***      
      IF(MYPE.EQ.0)THEN
      print *
      print *, ' **********DEBUG RUN ************'
      print *
        READ(5,MODTOP,END=12321)
12321   CONTINUE
      ENDIF
C
      CALL MPI_BCAST(ETOP,1,MPI_REAL,0,MPI_COMM_WORLD,IRTN)
C-----------------------------------------------------------------------
C
      REWIND 15
      READ(15,ECONDATA)
C-----------------------------------------------------------------------
C
C***  DEFINE HF TO BE TRUE IF INPUT DOMAIN IS IDENTICAL TO OUTPUT DOMAIN
C
      IF(TLM0DI.EQ.TLM0DO.AND.TPH0DI.EQ.TPH0DO.AND. 
     + WBDI.EQ.WBDO.AND.SBDI.EQ.SBDO.AND.DLMDI.EQ.
     + DLMDO.AND.DPHDI.EQ.DPHDO.AND.IMI.EQ.IMO.AND.
     + JMI.EQ.JMO)THEN
        HF=.TRUE.
      ELSE
        HF=.FALSE.
      ENDIF 
C
      if(mype.eq.0) then
       print*,'DLMDI,DLMDO,DPHDI,DPHDO= ',DLMDI,DLMDO,DPHDI,DPHDO
       print*,'IMI,JMI,IMO,JMO= ',IMI,JMI,IMO,JMO
       PRINT*,'IS INPUT DOMAIN EQ OUTPUT DOMAIN?', HF
      endif
C-----------------------------------------------------------------------
C
C***  ZERO OUT DUMMY OUTPUT ARRAY
C
      IF(MYPE.EQ.0)THEN    
        DO J=1,JMO
        DO I=1,IMO
          DUM2DOUT(I,J)=0.0
        ENDDO
        ENDDO
C
C***  ZERO OUT DUMMY ULOUT ARRAY
C
        DO L=1,2*LMO
          ULOUT(L)=0.0
        ENDDO
      ENDIF
C-----------------------------------------------------------------------
C
      LSFC = 12
      COMPWT=.TRUE.
c      SIGMA=.TRUE.
C***
C***  COMPUTE GEODETIC LAT/LON(POSITIVE EAST) POINTS OF INPUT GRID
C***  IN DEGREES
C***
      CALL ETALL(IMI,JMI,TLM0DI,TPH0DI,DLMDI,DPHDI,
     &           HLATI,HLONI,VLATI,VLONI)
C*** 
C***  COMPUTE GEODETIC LAT/LON POINTS OF TARGET GRID IN DEGREES
c 
      CALL ETALL(IMO,JMO,TLM0DO,TPH0DO,DLMDO,DPHDO,
     &           HLATO,HLONO,VLATO,VLONO)
      if(mype.eq.0)print*,'after calling etall'
C
      PI =3.141592654
      D2R=PI/180.
      R2D=1./D2R
C-----------------------------------------------------------------------
C***
C***  READY TO COMPUTE ROTATION ANGLES.
C***
C***  FORMULAS USE GEODETIC LONGITUDES POSITIVE WEST
C***  SO NEGATE LONGITUDES FROM ETALL (VLONO AND VLONI)
C***  AND THE CENTRAL LONGITUDES OF THE GRIDS
C***  SINCE THEY ARRIVE HERE AS NEGATIVE WEST.
C***
      ERLAM0=-TLM0DI*D2R
      ERPHI0=TPH0DI*D2R
      ERL0_IN=ERLAM0/D2R
      CPHI0_IN=COS(ERPHI0)
      SPHI0_IN=SIN(ERPHI0)
C
      ERLAM0=-TLM0DO*D2R
      ERPHI0=TPH0DO*D2R
      ERL0_OUT=ERLAM0/D2R
      CPHI0_OUT=COS(ERPHI0)
      SPHI0_OUT=SIN(ERPHI0)
C***
C***  COMPUTE EARTH ROTATION ANGLES FOR WINDS RELATIVE TO BOTH
C***  THE INPUT AND OUTPUT GRIDS ON THE OUTPUT GRID POINTS.
C***
      DO J=1,JMO
      DO I=1,IMO
        X=CPHI0_IN*COS(VLATO(I,J)*D2R)*COS((-VLONO(I,J)-ERL0_IN)*D2R)
     1   +SPHI0_IN*SIN(VLATO(I,J)*D2R)
        Y=-COS(VLATO(I,J)*D2R)*SIN((-VLONO(I,J)-ERL0_IN)*D2R)
        TVLONI=ATAN(Y/X)
        IF(X.LT.0.)TVLONI=TVLONI+PI
        ARG=SPHI0_IN*SIN(TVLONI)/COS(VLATO(I,J)*D2R)
        ARG=AMIN1(ARG,1.)
        ARG=AMAX1(ARG,-1.)
        ALPHA_IN(I,J)=ASIN(ARG)
C
        X=CPHI0_OUT*COS(VLATO(I,J)*D2R)*COS((-VLONO(I,J)-ERL0_OUT)*D2R)
     1   +SPHI0_OUT*SIN(VLATO(I,J)*D2R)
        Y=-COS(VLATO(I,J)*D2R)*SIN((-VLONO(I,J)-ERL0_OUT)*D2R)
        TVLONO=ATAN(Y/X)
        IF(X.LT.0.)TVLONO=TVLONO+PI
        ARG=SPHI0_OUT*SIN(TVLONO)/COS(VLATO(I,J)*D2R)
        ARG=AMIN1(ARG,1.)
        ARG=AMAX1(ARG,-1.)
        ALPHA_OUT(I,J)=ASIN(ARG)
C
      ENDDO
      ENDDO
C
C----------------------------------------------------------------------
C***  IF COMPWT = TRUE COMPUTE INDICES / WEIGHTS, ELSE READ
C***  THEM IN VIA UNIT 12
C----------------------------------------------------------------------
C
      IF(COMPWT)THEN
        DO J=JSTA,JEND
        DO I=1,IMO
          GLATD=HLATO(I,J)
          GLOND=360.-HLONO(I,J)
          VLATD=VLATO(I,J)
          VLOND=360.-VLONO(I,J)
          TLM0DN=-TLM0DI
          GLATDX=GLATD
          GLONDX=GLOND
C
          glater=GLATD
          gloner=GLOND
C
C***  FIND NEAREST INPUT GRID V POINT TO TARGET GRID H POINT  
C
          CALL G2T2V(GLATDX,GLONDX,IMJMO,IMI,JMI,TPH0DI,TLM0DN
     1,              DPHDI,DLMDI,IHINX(I,J),IHINY(I,J))

          if(mype.eq.0) then
            if(i.eq.1.and.j.eq.1) print *,'at mype=0,i=1,j=1 ',
     1         GLATER,GLONER,ihinx(1,1),ihiny(1,1)
          endif

          IGAR=IMI-MOD(IHINY(I,J),2)
C
C----------------------------------------------------------------------
          IF(IHINX(I,J).GT.IGAR)THEN
C----------------------------------------------------------------------
C
            IHINX(I,J)=IMI
C
            IF(MOD(IHINY(I,J),2).EQ.1)THEN
              IF(IHINY(I,J).EQ.1)THEN
                IHINY(I,J)=2
              ELSE IF(IHINY(I,J).EQ.JMI)THEN
                IHINY(I,J)=JMI-1
              ELSE
                ELATO=SBDO+REAL(J-1)*DPHDO
                ELATI1=SBDI+FLOAT(IHINY(I,J)+1-1)*DPHDI
                ELATI2=SBDI+FLOAT(IHINY(I,J)-1-1)*DPHDI
                GAR1=ABS(ELATO-ELATI1)
                GAR2=ABS(ELATO-ELATI2)
C
                IF(GAR1.GT.GAR2)THEN
                  IHINY(I,J)=IHINY(I,J)-1
                ELSE
                  IHINY(I,J)=IHINY(I,J)+1
                ENDIF
              ENDIF 
            ENDIF  
C----------------------------------------------------------------------
          ELSEIF(IHINX(I,J).LT.1)THEN
C----------------------------------------------------------------------
            IHINX(I,J)=1
C
            IF(MOD(IHINY(I,J),2).EQ.1)THEN
              IF(IHINY(I,J).EQ.1)THEN
                IHINY(I,J)=2
              ELSEIF(IHINY(I,J).EQ.JMI)THEN
                IHINY(I,J)=JMI-1 
              ELSE 
                ELATO=SBDO+REAL(J-1)*DPHDO 
                ELATI1=SBDI+REAL(IHINY(I,J)+1-1)*DPHDI
                ELATI2=SBDI+REAL(IHINY(I,J)-1-1)*DPHDI
                GAR1=ABS(ELATO-ELATI1)
                GAR2=ABS(ELATO-ELATI2)
C
                IF(GAR1.GT.GAR2)THEN
                  IHINY(I,J)=IHINY(I,J)-1
                ELSE
                  IHINY(I,J)=IHINY(I,J)+1
                ENDIF
              ENDIF
            ENDIF
C----------------------------------------------------------------------
          ENDIF
C----------------------------------------------------------------------
C
C----------------------------------------------------------------------
          IF(IHINY(I,J).LT.1)THEN
            IHINY(I,J)=1
          ENDIF
C
          IF(IHINY(I,J).GT.JMI)THEN
            IHINY(I,J)=JMI
          ENDIF
C
          IGAR=IMI-MOD(IHINY(I,J),2)
c         IF(IHINX(I,J).LT.1.OR.IHINX(I,J).GT.IGAR.OR.IHINY(I,J).LT.1
c    1    .OR.IHINY(I,J).GT.JMI)PRINT*,'enormal ihin',I,J,IHINX(I,J)
c    2    ,IHINY(I,J),IGAR
C
C----------------------------------------------------------------------
C***  IVIN IS THE INDEX OF THE INPUT GRID H POINT CLOSEST TO THE 
C***  OUTPUT GRID'S V-POINT.
C***  USE CLOSEST H POINT TO FIND THE CORRECT STEP.
C----------------------------------------------------------------------
C
          CALL LL2KIN(VLATD,VLOND,IVINX(I,J),IVINY(I,J)
     1,               D2R,R2D,TPH0DI,TLM0DN,DPHDI,DLMDI,LIST)
C
          if(mype.eq.0) then
            if(i.eq.imo.and.j.eq.1) print *,'at mype=0,i=imo,j=1 ',
     1         vlatd,vlond,ivinx(imo,1),iviny(imo,1)
          endif
C
          IGAR=IMI+MOD(IVINY(I,J),2)-1
C
          IF(IVINX(I,J).GT.IGAR)THEN
            IVINX(I,J)=IMI
C
            IF(MOD(IVINY(I,J),2).EQ.0)THEN
              ELATO=SBDO+REAL(J-1)*DPHDO
              ELATI1=SBDI+REAL(IVINY(I,J)+1-1)*DPHDI
              ELATI2=SBDI+REAL(IVINY(I,J)-1-1)*DPHDI
              GAR1=ABS(ELATO-ELATI1)
              GAR2=ABS(ELATO-ELATI2) 
C
              IF(GAR1.GT.GAR2)THEN
                IVINY(I,J)=IVINY(I,J)-1
              ELSE
                IVINY(I,J)=IVINY(I,J)+1
              ENDIF
            ENDIF 
C
          ELSEIF(IVINX(I,J).LT.1)THEN
            IVINX(I,J)=1
C
            IF(MOD(IVINY(I,J),2).EQ.0)THEN
              ELATO=SBDO+REAL(J-1)*DPHDO 
              ELATI1=SBDI+REAL(IVINY(I,J)+1-1)*DPHDI
              ELATI2=SBDI+REAL(IVINY(I,J)-1-1)*DPHDI
              GAR1=ABS(ELATO-ELATI1)
              GAR2=ABS(ELATO-ELATI2)
C
              IF(GAR1.GT.GAR2)THEN
                IVINY(I,J)=IVINY(I,J)-1
              ELSE
                IVINY(I,J)=IVINY(I,J)+1
              ENDIF 
            ENDIF
          ENDIF
C
          IF(IVINY(I,J).LT.1)THEN
            IVINY(I,J)=1
          ENDIF
C
          IF(IVINY(I,J).GT.JMI)THEN
            IVINY(I,J)=JMI
          ENDIF
C
          IGAR=IMI+MOD(IVINY(I,J),2)-1
c
c         IF(IVINX(I,J).LT.1.OR.IVINX(I,J).GT.IGAR.OR.IVINY(i,j).LT.1
c    1    .OR.IVINY(I,J).GT.JMI)PRINT*,'enormal ivin',I,J,IVINX(I,J)
c    2    ,IVINY(i,j),IGAR
C
C----------------------------------------------------------------------
C***  IH2H IS THE INDEX OF THE INPUT GRID H POINT CLOSEST TO THE 
C***  OUTPUT GRID'S H-POINT 
C----------------------------------------------------------------------
C
          CALL G2T2H(I,J,GLATD,GLOND,IMI,JMI,TPH0DI,TLM0DI
     1,              DPHDI,DLMDI,IH2HX(i,j),IH2HY(I,J))
C
          IGAR=IMI+MOD(IH2HY(I,J),2)-1
C
          IF(IH2HX(I,J).GT.IGAR)THEN
            IH2HX(I,J)=IMI
C
            IF(MOD(IH2HY(I,J),2).EQ.0)THEN
              ELATO=SBDO+REAL(J-1)*DPHDO
              ELATI1=SBDI+REAL(IH2HY(I,J)+1-1)*DPHDI
              ELATI2=SBDI+REAL(IH2HY(I,J)-1-1)*DPHDI
              GAR1=ABS(ELATO-ELATI1)
              GAR2=ABS(ELATO-ELATI2)
C
              IF(GAR1.GT.GAR2)THEN
                IH2HY(I,J)=IH2HY(I,J)-1
              ELSE
                IH2HY(I,J)=IH2HY(I,J)+1
              ENDIF
            ENDIF
C
          ELSEIF(IH2HX(I,J).LT.1)THEN
            IH2HX(I,J)=1
C
            IF(MOD(IH2HY(I,J),2).EQ.0)THEN
              ELATO=SBDO+REAL(J-1)*DPHDO
              ELATI1=SBDI+REAL(IH2HY(I,J)+1-1)*DPHDI
              ELATI2=SBDI+REAL(IH2HY(I,J)-1-1)*DPHDI
              GAR1=ABS(ELATO-ELATI1)
              GAR2=ABS(ELATO-ELATI2)
C
              IF(GAR1.GT.GAR2)THEN
                IH2HY(I,J)=IH2HY(I,J)-1
              ELSE 
                IH2HY(I,J)=IH2HY(I,J)+1
              ENDIF
            ENDIF  
          ENDIF
C
          IF(IH2HY(I,J).LT.1)THEN
            IH2HY(I,J)=1
          ENDIF
C
          IF(IH2HY(I,J).GT.JMI)THEN
            IH2HY(I,J)=JMI
          ENDIF
C
          IGAR=IMI+MOD(IH2HY(I,J),2)-1 
c
c         IF(IH2HX(I,J).LT.1.OR.IH2HX(I,J).GT.IGAR.OR.IH2HY(i,j).LT.1
c    1    .OR.IH2HY(I,J).GT.JMI)PRINT*,'enormal ih2h',I,J,IH2HX(I,J)
c    2    ,IH2HY(i,j),IGAR
C
C----------------------------------------------------------------------
C***  COMPUTE INTERPOLATION WEIGHTS FOR BILINEAR INTERPOLATION
C***  OF WIND AND MASS POINTS 
C----------------------------------------------------------------------
C
C***  FIRST, COMPUTE DISTANCE OF TARGET GRID V-POINT K TO FOUR V-POINTS
C***  ON INPUT GRID STEP
C
C               V
C             
C
C         V     H     V
C             v
C
C               V
C
C 
C***  COMPUTE BILINEAR INTERPOLATION WEIGHTS FOR INTERPOLATION 
C***  OF INPUT V's TO TARGET V's
C
C***  FIXES FOR WHEN BOUNDARIES OF INPUT AND OUTPUT DOMAINS OVERLAP
C
C NOTE: OVERLAP CODE ONLY WORKS FOR CERTAIN FOR 8-km AND 4-km HAWAII AND
C       PUERTO RICO GRIDS. IT HAS NOT BEEN TESTED FOR ANY OTHER 
C       CONFIGURATION AND IT IS STRONGLY ADVISED TO MAKE SURE THE 
C       NESTED DOMAIN DOES NOT OVERLAP THE BOUNDARY OF THE INPUT ETA DOMAIN!!
C
          IF(IVINY(I,J).EQ.1.AND.IVINX(I,J).EQ.1)THEN
            DLON=ABS(VLONO(I,J)-HLONI(1,1))
            DLAT=ABS(VLATO(I,J)-HLATI(1,1))
c           DLON=ABS(WBDO+(REAL(I)*2.-1.)*DLMDO-WBDI)
c           DLAT=ABS(SBDO+REAL(J-1)*DPHDO-SBDI)
C
            IF(DLON.GE.DLAT)THEN
              print *,'OVERLAP 1a ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELONO=WBDO+(REAL(I)*2.-1.)*DLMDO
c             ELONI1=WBDI+DLMDI
c             ELONI2=WBDI+3.*DLMDI
              ELONO=VLONO(I,J)
              ELONI1=HLONI(IVINX(I,J),IVINY(I,J))
              ELONI2=HLONI(IVINX(I,J)+1,IVINY(I,J))
              WV(I,J,1)=(ELONO-ELONI2)/(ELONI1-ELONI2)
              WV(I,J,2)=0.
              WV(I,J,3)=(ELONI1-ELONO)/(ELONI1-ELONI2)
              WV(I,J,4)=0.
            ELSE
              print *,'OVERLAP 1b ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELATO=SBDO+REAL(J-1)*DPHDO
c             ELATI1=SBDI+DPHDI
c             ELATI2=SBDI+3.*DPHDI
              ELATO=VLATO(I,J)
              ELATI1=HLATI(IVINX(I,J),IVINY(I,J))
              ELATI2=HLATI(IVINX(I,J),IVINY(I,J)+1)
              WV(I,J,1)=0.
              WV(I,J,2)=(ELATI1-ELATO)/(ELATI1-ELATI2)
              WV(I,J,3)=0.
              WV(I,J,4)=(ELATO-ELATI2)/(ELATI1-ELATI2)
            ENDIF
C
          ELSEIF(IVINY(I,J).EQ.1.AND.IVINX(I,J).EQ.IMI)THEN
            DLON=ABS(VLONO(I,J)-HLONI(IMI-1,1))
            DLAT=ABS(VLATO(I,J)-HLATI(IMI,1))
c           DLON=ABS(WBDO+(REAL(I)*2.-1.)*DLMDO-(WBDI+2.*(IMI-1)
c    1              *DLMDI))
c           DLAT=ABS(SBDO+REAL(J-1)*DPHDO-SBDI) 

            IF(DLON.GE.DLAT)THEN
              print *,'OVERLAP 2a ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELONO=WBDO+(REAL(I)*2.-1.)*DLMDO
c             ELONI1=WBDI+(2.*(IMI-2)-1)*DLMDI
c             ELONI2=WBDI+(2.*(IMI-1)-1)*DLMDI
              ELONO=VLONO(I,J)
              ELONI1=HLONI(IVINX(I,J)-2,IVINY(I,J))
              ELONI2=HLONI(IVINX(I,J)-1,IVINY(I,J))
              WV(I,J,1)=(ELONO-ELONI2)/(ELONI1-ELONI2)
              WV(I,J,2)=0.
              WV(I,J,3)=(ELONI1-ELONO)/(ELONI1-ELONI2)
              WV(I,J,4)=0.
            ELSE
              print *,'OVERLAP 2b ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELATO=SBDO+REAL(J-1)*DPHDO
c             ELATI1=SBDI+DPHDI
c             ELATI2=SBDI+3.*DPHDI
              ELATO=VLATO(I,J)
              ELATI1=HLATI(IVINX(I,J),IVINY(I,J))
              ELATI2=HLATI(IVINX(I,J),IVINY(I,J)+1)
              WV(I,J,1)=0.
              WV(I,J,2)=(ELATI1-ELATO)/(ELATI1-ELATI2)
              WV(I,J,3)=0.
              WV(I,J,4)=(ELATO-ELATI2)/(ELATI1-ELATI2)
            ENDIF
C
          ELSEIF(IVINY(I,J).EQ.JMI.AND.IVINX(I,J).EQ.IMI)THEN
            DLON=ABS(VLONO(I,J)-HLONI(IMI-1,JMI))
            DLAT=ABS(VLATO(I,J)-HLATI(IMI,JMI-1))
c           DLON=ABS(WBDO+(REAL(I)*2.-1.)*DLMDO-(WBDI+2.*(IMI-1)
c    1              *DLMDI))
c           DLAT=ABS(SBDO+REAL(J-1)*DPHDO-SBDI-REAL(JMI-1)*DPHDI) 
C
            IF(DLON.GE.DLAT)THEN
              print *,'OVERLAP 3a ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELONO=WBDO+(REAL(I)*2.-1.)*DLMDO
c             ELONI1=WBDI+(2.*(IMI-2)-1)*DLMDI
c             ELONI2=WBDI+(2.*(IMI-1)-1)*DLMDI
              ELONO=VLONO(I,J)
              ELONI1=HLONI(IVINX(I,J)-2,IVINY(I,J))
              ELONI2=HLONI(IVINX(I,J)-1,IVINY(I,J))
              WV(I,J,1)=(ELONO-ELONI2)/(ELONI1-ELONI2)
              WV(I,J,2)=0.
              WV(I,J,3)=(ELONI1-ELONO)/(ELONI1-ELONI2)
              WV(I,J,4)=0.
            ELSE
              print *,'OVERLAP 3b ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELATO=SBDO+REAL(J-1)*DPHDO
c             ELATI1=SBDI+REAL(JMI-3-1)*DPHDI
c             ELATI2=SBDI+REAL(JMI-1-1)*DPHDI
              ELATO=VLATO(I,J)
              ELATI1=HLATI(IVINX(I,J),IVINY(I,J)-4)
              ELATI2=HLATI(IVINX(I,J),IVINY(I,J)-2)
              WV(I,J,1)=0.
              WV(I,J,2)=(ELATI1-ELATO)/(ELATI1-ELATI2)
              WV(I,J,3)=0.
              WV(I,J,4)=(ELATO-ELATI2)/(ELATI1-ELATI2)
            ENDIF
C
          ELSEIF(IVINY(I,J).EQ.JMI.AND.IVINX(I,J).EQ.1)THEN
            DLON=ABS(VLONO(I,J)-HLONI(1,JMI))
            DLAT=ABS(VLATO(I,J)-HLATI(1,JMI-1))
c           DLON=ABS(WBDO+(REAL(I)*2.-1.)*DLMDO-WBDI)
c           DLAT=ABS(SBDO+REAL(J-1)*DPHDO-SBDI-REAL(JMI-1)*DPHDI)
C
            IF(DLON.GE.DLAT)THEN
              print *,'OVERLAP 4a ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELONO=WBDO+(REAL(I)*2.-1.)*DLMDO
c             ELONI1=WBDI+DLMDI
c             ELONI2=WBDI+3.*DLMDI
              ELONO=VLONO(I,J)
              ELONI1=HLONI(IVINX(I,J),IVINY(I,J))
              ELONI2=HLONI(IVINX(I,J)+1,IVINY(I,J))
              WV(I,J,1)=(ELONO-ELONI2)/(ELONI1-ELONI2)
              WV(I,J,2)=0.
              WV(I,J,3)=(ELONI1-ELONO)/(ELONI1-ELONI2)
              WV(I,J,4)=0.
            ELSE 
              print *,'OVERLAP 4b ',IVINY(I,J),IVINX(I,J),DLAT,DLON
c             ELATO=SBDO+REAL(J-1)*DPHDO
c             ELATI1=SBDI+REAL(JMI-3-1)*DPHDI
c             ELATI2=SBDI+REAL(JMI-1-1)*DPHDI
              ELATO=VLATO(I,J)
              ELATI1=HLATI(IVINX(I,J),IVINY(I,J)-4)
              ELATI2=HLATI(IVINX(I,J),IVINY(I,J)-2)
              WV(I,J,1)=0.
              WV(I,J,2)=(ELATI1-ELATO)/(ELATI1-ELATI2)
              WV(I,J,3)=0.
              WV(I,J,4)=(ELATO-ELATI2)/(ELATI1-ELATI2)
            ENDIF 
C
          ELSEIF(IVINY(I,J).EQ.1.OR.IVINY(I,J).EQ.JMI)THEN  !ASSUME JMI ODD
C
            print *,'OVERLAP 5 ',IVINY(I,J),IVINX(I,J)
c           ELONO=WBDO+(REAL(I)*2.-1.)*DLMDO
c           ELONI1=WBDI+(2.*(REAL(IVINX(I,J))-1.)-1.)*DLMDI
c           ELONI2=WBDI+(2.*REAL(IVINX(I,J))-1.)*DLMDI 
            ELONO=VLONO(I,J)
            ELONI1=HLATI(IVINX(I,J)-1,IVINY(I,J))
            ELONI2=HLATI(IVINX(I,J),IVINY(I,J))
            WV(I,J,1)=(ELONO-ELONI2)/(ELONI1-ELONI2)
            WV(I,J,2)=0.
            WV(I,J,3)=(ELONI1-ELONO)/(ELONI1-ELONI2)
            WV(I,J,4)=0.
C
          ELSEIF(IVINX(I,J).EQ.1.OR.IVINX(I,J).EQ.IMI)THEN
C
            print *,'OVERLAP 6 ',IVINY(I,J),IVINX(I,J)
c           ELATO=SBDO+REAL(J-1)*DPHDO
c           ELATI1=SBDI+REAL(IVINY(I,J)-1-1)*DPHDI
c           ELATI2=SBDI+REAL(IVINY(I,J)+1-1)*DPHDI
            ELATO=VLATO(I,J)
            ELATI1=HLATI(IVINX(I,J),IVINY(I,J)-1)
            ELATI2=HLATI(IVINX(I,J),IVINY(I,J)+1)
            WV(I,J,1)=0.
            WV(I,J,2)=(ELATI1-ELATO)/(ELATI1-ELATI2)
            WV(I,J,3)=0.
            WV(I,J,4)=(ELATO-ELATI2)/(ELATI1-ELATI2)
            if(mype.eq.0) then
             if(i.eq.imo.and.j.eq.1) then
             print *,'intrstv ',i,j,ELATO,SBDO,REAL(J-1),DPHDO
             print *,'intrstv ',i,j,ELATI1,SBDI,REAL(IHINY(I,J)-1-1),
     1               DPHDI,IHINY(I,J)
             print *,'intrstv ',i,j,ELATI2,SBDI,REAL(IHINY(I,J)+1-1),
     1               DPHDI,IHINY(I,J)
             print *,'intrstv ',wv(i,j,1),wv(i,j,2),wv(i,j,3),
     1               wv(i,j,4)
             endif
            endif
C
          ELSE 
            PHI1=VLATO(I,J)*D2R
            LAM1=VLONO(I,J)*D2R
            COSPH1=COS(PHI1)
            SINPH1=SIN(PHI1)
            SUMDEL=0.0
C
C----------------------------------------------------------------------
            DO KVPT=1,4
C----------------------------------------------------------------------
              IF(MOD(IVINY(I,J),2).LT.1)THEN 
	        IF(KVPT.EQ.1)THEN 
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)
                ELSEIF(KVPT.EQ.2)THEN
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)+1
                ELSEIF(KVPT.EQ.3)THEN
                  IDUM=IVINX(I,J)+1
                  JDUM=IVINY(I,J)
                ELSEIF(KVPT.EQ.4)THEN
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)-1
	        ENDIF 
	      ELSE
                IF(KVPT.EQ.1)THEN 
                  IDUM=IVINX(I,J)-1
                  JDUM=IVINY(I,J)
                ELSEIF(KVPT.EQ.2)THEN
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)+1
                ELSEIF(KVPT.EQ.3)THEN
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)
                ELSEIF(KVPT.EQ.4)THEN
                  IDUM=IVINX(I,J)
                  JDUM=IVINY(I,J)-1
	        ENDIF
	      ENDIF  
C
              PHI2=VLATI(IDUM,JDUM)*D2R
              LAM2=VLONI(IDUM,JDUM)*D2R 
              SINPH2=SIN(PHI2)
              COSPH2=COS(PHI2)
              COSDIF=COS(LAM1-LAM2)
              T1=COSPH1*COSPH2*COSDIf
              T2=SINPH1*SINPH2
              GAR=T1+T2
              IF(GAR.GT.1.)GAR=1.
              IF(GAR.LT.-1.)GAR=-1.
              DELTA(KVPT)=DACOS(GAR)
C----------------------------------------------------------------------
            ENDDO
C----------------------------------------------------------------------
C
            WV(I,J,1)=0.
            WV(I,J,2)=0.
            WV(I,J,3)=0.
            WV(I,J,4)=0.
C
            IF(DELTA(1).LT.1.E-8)THEN
              WV(I,J,1)=1.
            ELSEIF(DELTA(2).LT.1.E-8)THEN
              WV(I,J,2)=1.
            ELSEIF(DELTA(3).LT.1.E-8)THEN
              WV(I,J,3)=1.
            ELSEIF(DELTA(4).LT.1.E-8)THEN
              WV(I,J,4)=1.
            ELSE
              DEL1=1./DELTA(1)
              DEL2=1./DELTA(2)
              DEL3=1./DELTA(3)
              DEL4=1./DELTA(4)
              SUMDEL=DEL1+DEL2+DEL3+DEL4
              WV(I,J,1)=DEL1/SUMDEL  
              WV(I,J,2)=DEL2/SUMDEL  
              WV(I,J,3)=DEL3/SUMDEL  
              WV(I,J,4)=DEL4/SUMDEL  
            ENDIF
          ENDIF
C
C----------------------------------------------------------------------
C***
C***  NEXT, COMPUTE DISTANCE OF TARGET GRID H-POINT K TO FOUR H-POINTS
C***  ON INPUT GRID STEP
C***
C----------------------------------------------------------------------
C
C               H
C             
C
C         H     V     H
C             h
C
C               H
C 
C----------------------------------------------------------------------
C***  COMPUTE BILINEAR INTERPOLATION WEIGHTS FOR INTERPOLATION 
C***  OF VARIABLES ON INPUT h'S TO TARGET H's
C----------------------------------------------------------------------
C
          IF(IHINY(I,J).EQ.1.OR.IHINY(I,J).EQ.JMI)THEN
            print *,'OVERLAP 7 ',IHINY(I,J),IHINX(I,J)
c           ELONO=WBDO+REAL(I-1)*2.*DLMDO
c           ELONI1=WBDI+2.*REAL(IHINX(I,J)-1)*DLMDI
c           ELONI2=WBDI+2.*REAL(IHINX(I,J)-1+1)*DLMDI
            ELON0=HLONO(I,J)
            ELONI1=VLONI(IHINX(I,J),J)
            ELONI2=VLONI(IHINX(I,J)+1,J)
            WH(I,J,1)=(ELONI2-ELONO)/(ELONI2-ELONI1)
            WH(I,J,2)=0.
            WH(I,J,3)=(ELONO-ELONI1)/(ELONI2-ELONI1)
            WH(I,J,4)=0.
          ELSEIF(IHINX(I,J).EQ.1.OR.IHINX(I,J).EQ.IMI)THEN
            print *,'OVERLAP 8 ',IHINY(I,J),IHINX(I,J)
c           ELATO=SBDO+REAL(J-1)*DPHDO
c           ELATI1=SBDI+REAL(IHINY(I,J)-1-1)*DPHDI
c           ELATI2=SBDI+REAL(IHINY(I,J)+1-1)*DPHDI
            ELATO=HLATO(I,J)
            ELATI1=VLATI(I,IHINY(I,J)-2)
            ELATI2=VLATI(I,IHINY(I,J)+2)
            WH(I,J,1)=0.
            WH(I,J,2)=(ELATO-ELATI1)/(ELATI2-ELATI1)
            WH(I,J,3)=0.
            WH(I,J,4)=(ELATI2-ELATO)/(ELATI2-ELATI1)
            if(mype.eq.0) then
              if(i.eq.1.and.j.eq.1) then
               print *,'intrst ',i,j,ELATO,SBDO,REAL(J-1),DPHDO
               print *,'intrst ',i,j,ELATI1,SBDI,REAL(IHINY(I,J)-2),
     1                 DPHDI,IHINY(I,J)
               print *,'intrst ',i,j,ELATI2,SBDI,REAL(IHINY(I,J)+2),
     1                 DPHDI,IHINY(I,J)
               print *,'intrst ',wh(i,j,1),wh(i,j,2),wh(i,j,3),wh(i,j,4)
              endif
            endif
          ELSE
            PHI1=HLATO(I,J)*D2R
            LAM1=HLONO(I,J)*D2R
            COSPH1=COS(PHI1)
            SINPH1=SIN(PHI1)
            SUMDEL=0.
C
C----------------------------------------------------------------------
            DO KHPT=1,4
C----------------------------------------------------------------------
              IF(MOD(IHINY(I,J),2).LT.1)THEN 
                IF(KHPT.EQ.1)THEN 
                  IDUM=IHINX(I,J)-1
                  JDUM=IHINY(I,J)
                ELSEIF(KHPT.EQ.2)THEN
                  IDUM=IHINX(I,J)
                  JDUM=IHINY(I,J)+1
                ELSEIF(KHPT.EQ.3)THEN
                  IDUM=IHINX(I,J)
                  JDUM=IHINY(I,J)
                ELSEIF(KHPT.EQ.4)THEN
                  IDUM=IHINX(I,J)
                  JDUM=IHINY(I,J)-1
                ENDIF 
C
              ELSE
                IF(KHPT.EQ.1)THEN 
                  IDUM=IHINX(I,J)
                   JDUM=IHINY(I,J)
                ELSEIF(KHPT.EQ.2)THEN
                  IDUM=IHINX(I,J)
                  JDUM=IHINY(I,J)+1
                ELSEIF(KHPT.EQ.3)THEN
                  IDUM=IHINX(I,J)+1
                  JDUM=IHINY(I,J)
                ELSEIF(KHPT.EQ.4)THEN
                  IDUM=IHINX(I,J)
                  JDUM=IHINY(I,J)-1
                ENDIF
              ENDIF  
C
              PHI2=HLATI(IDUM,JDUM)*D2R
              LAM2=HLONI(IDUM,JDUM)*D2R
              SINPH2=SIN(PHI2)
              COSPH2=COS(PHI2)
              COSDIF=COS(LAM1-LAM2)
              T1=COSPH1*COSPH2*COSDIF
              T2=SINPH1*SINPH2
              GAR=T1+T2
              IF(GAR.GT.1.)GAR=1.
              IF(GAR.LT.-1.)GAR=-1.
              DELTA(KHPT)=DACOS(GAR)
C----------------------------------------------------------------------
            ENDDO
C----------------------------------------------------------------------
C
            WH(I,J,1)=0.
            WH(I,J,2)=0.
            WH(I,J,3)=0.
            WH(I,J,4)=0.
C
            IF(DELTA(1).LT.1.E-8)THEN
              WH(I,J,1)=1.
            ELSEIF(DELTA(2).LT.1.E-8)THEN
              WH(I,J,2)=1.
            ELSEIF(DELTA(3).LT.1.E-8)THEN
              WH(I,J,3)=1.
            ELSEIF(DELTA(4).LT.1.E-8)THEN
              WH(I,J,4)=1.
            ELSE
              DEL1=1./DELTA(1)
              DEL2=1./DELTA(2)
              DEL3=1./DELTA(3)
              DEL4=1./DELTA(4)
              SUMDEL=DEL1+DEL2+DEL3+DEL4
              WH(I,J,1)=DEL1/SUMDEL
              WH(I,J,2)=DEL2/SUMDEL
              WH(I,J,3)=DEL3/SUMDEL
              WH(I,J,4)=DEL4/SUMDEL
            ENDIF
          ENDIF
C----------------------------------------------------------------------
        ENDDO
        ENDDO  ! End of I,J loop
C----------------------------------------------------------------------
      ELSEIF(.NOT.COMPWT)THEN
          READ(13)IHINX,IHINY,IVINX,IVINY,WH,WV 
      ENDIF
C----------------------------------------------------------------------
C
C***  COMPUTE HEIGHT MASKS ON INPUT GRID (NEEDED FOR INTMV)
C
      READ(19) 
      READ(19) 
C
      IF(DPHDI.LT.0.1.AND.DLMDI.LT.0.1)THEN
        READ(19) HTMI
        READ(19) LMHI
        READ(19) VTMI
        READ(19) LMVI
      ELSE
        READ(19) HTMI
        READ(19) VTMI
        READ(19) LMHI
        READ(19) LMVI  
      ENDIF 
      if(mype.eq.0) print *," done with reading input mask" 
C----------------------------------------------------------------------
C
C***  INTERPOLATE/MOVE INPUT GRID POINTS TO TARGET GRID POINTS
C
      ALLOCATE(TI(IMO,JSTA:JEND,LMI))
      ALLOCATE(QI(IMO,JSTA:JEND,LMI))
      ALLOCATE(UI(IMO,JSTA:JEND,LMI)) 
      ALLOCATE(VI(IMO,JSTA:JEND,LMI))
      ALLOCATE(Q2I(IMO,JSTA:JEND,LMI))
      ALLOCATE(CLDLIN(IMO,JSTA:JEND,LMI))
C
C***  IF HF = TRUE, NO NEED TO DO H INTERPOLATION
C
      IF(HF)THEN
        CALL READIC(UI,VI,TI,QI,Q2I,CLDLIN)
      ELSE
        CALL INTMV(UI,VI,TI,QI,Q2I,CLDLIN)
      ENDIF 
C----------------------------------------------------------------------
C***
C***  COMPUTE HEIGHT MASKS ON TARGET GRID (NEEDED FOR PTETA/ETA2HYB)
C***
c      write(6,*) 'calling maskout'
      ALLOCATE(DUM3DO(IMO,JMO,LMO))
      ALLOCATE(LMHO(IMO,JSTA:JEND))
      ALLOCATE(LMVO(IMO,JSTA:JEND))
      ALLOCATE(HTMO(IMO,JSTA:JEND,LMO))
      ALLOCATE(VTMO(IMO,JSTA:JEND,LMO))
      if(mype.eq.0)write(0,*)' after allocate masks sigma=',sigma
C
C----------------------------------------------------------------------
      IF(SIGMA)THEN
        DO J=JSTA,JEND
        DO I=1,IMO
          LMHO(I,J)=LMO
          LMVO(I,J)=LMO
C
          DO L=1,LMO
	    HTMO(I,J,L)=1.0
	    VTMO(I,J,L)=1.0
          ENDDO
        ENDDO
        ENDDO
      ELSE 
        REWIND 18	  
        READ(18) 
        READ(18) 
C
        IF(DPHDO.LT.0.1.AND.DLMDO.LT.0.1)THEN
          READ(18)DUM3DO
C
          DO L=1,LMO
            DO J=JSTA,JEND
            DO I=1,IMO
              HTMO(I,J,L)=DUM3DO(I,J,L)
            ENDDO
            ENDDO
          ENDDO 
C
          READ(18)IDUM2DOUT
          DO J=JSTA,JEND
          DO I=1,IMO
            LMHO(I,J)=IDUM2DOUT(I,J)
          ENDDO
          ENDDO 
C
          READ(18)DUM3DO
          DO L=1,LMO
            DO J=JSTA,JEND
            DO I=1,IMO
              VTMO(I,J,L)=DUM3DO(I,J,L)
            ENDDO
            ENDDO
          ENDDO 
C
          READ(18)IDUM2DOUT
          DO J=JSTA,JEND
          DO I=1,IMO
            LMVO(I,J)=IDUM2DOUT(I,J)
          ENDDO
          ENDDO 
c        read(18)htmo
c        read(18)lmho
c        read(18)vtmo
c        read(18)lmvo
C
        ELSE
          READ(18)DUM3DO
          DO L=1,LMO
            DO J=JSTA,JEND
            DO I=1,IMO
              HTMO(I,J,L)=DUM3DO(I,J,L)
            ENDDO
            ENDDO
          ENDDO 
C
          READ(18)DUM3DO
          DO L=1,LMO
            DO J=JSTA,JEND
            DO I=1,IMO
              VTMO(I,J,L)=DUM3DO(I,J,L)
            ENDDO
            ENDDO
          ENDDO 
C
          READ(18)IDUM2DOUT
          DO J=JSTA,JEND
          DO I=1,IMO
            LMHO(I,J)=IDUM2DOUT(I,J)
          ENDDO
          ENDDO 
C
          READ(18)IDUM2DOUT
          DO J=JSTA,JEND
          DO I=1,IMO
            LMVO(I,J)=IDUM2DOUT(I,J)
          ENDDO
          ENDDO 
c        read(18)htmo
c        read(18)vtmo
c        read(18)lmho
c        read(18)lmvo
C
        ENDIF
C
      ENDIF
C----------------------------------------------------------------------
C
      DEALLOCATE(DUM3DO)
c      print *," done with maskout" 
C
C----------------------------------------------------------------------
C
C***  PERFORM VERTICAL INTERPOLATION OF 3-D FIELDS 
C
C----------------------------------------------------------------------
C     write(6,*) 'calling ptetae'
      ALLOCATE(TO(IMO,JSTA:JEND,LMO))
      ALLOCATE(QO(IMO,JSTA:JEND,LMO))
      ALLOCATE(UO(IMO,JSTA:JEND,LMO))
      ALLOCATE(VO(IMO,JSTA:JEND,LMO))
      ALLOCATE(CWMO(IMO,JSTA:JEND,LMO))
      ALLOCATE(Q2O(IMO,JSTA:JEND,LMO))
C
      IF(SIGMA)THEN
        if(mype.eq.0) then
        print*,'calling eta2hyb to interpolate from eta to hybrid'
        endif
C        CALL ETA2HYB(IHINX,IHINY,ETOP,HF,TO,QO,UO,VO,CWMO,Q2O
C     1,              UI,VI,TI,QI,Q2I,CLDLIN)
        CALL ETA2HYBSPLINE(IHINX,IHINY,ETOP,HF,TO,QO,UO,VO,CWMO,Q2O
     1,              UI,VI,TI,QI,Q2I,CLDLIN)
      ELSE
        if(mype.eq.0) then
         print*,'calling ptetae to interpolate from eta to eta'
        endif
        CALL PTETAE(IHINX,IHINY,ETOP,HF,TO,QO,UO,VO,CWMO,Q2O
     1,             UI,VI,TI,QI,Q2I,CLDLIN,HTMO,VTMO,LMHO,LMVO)
      ENDIF 	
C----------------------------------------------------------------------
C
C***  CALL CNSTS SUBROUTINE TO COMPUTE FIXED FIELDS.
C***  WRITE OUT NHB FILE AND PROCESS SURFACE VARIABLES.
C
      IF(SIGMA)THEN
       if(mype.eq.0)WRITE(6,*)'CALLING CNSTSHYB'
       CALL CNSTSHYB(htmo,vtmo,lmho,lmvo)
      ELSE
       if(mype.eq.0)write(6,*) 'CALLING CNSTS'
       CALL CNSTS(htmo,vtmo,lmho,lmvo)
      END IF
        if(mype.eq.0)write(6,*) 'back from cnsts'
C----------------------------------------------------------------------
C
C***  WRITE OUT TARGET GRID RESTART FILE
C
      NFCSTO = 51
      NTSD = 0
      ARDSW = 0.0
      ARDLW = 0.0
      ASRFC = 0.0
      AVRAIN = 0.0
      AVCNVC = 0.0
C
C***  BEFORE WRITING OUT RESTRT FILE, CONVERT RESO TO
C***  1/REFO (IT WAS SET =REFO IN PTETAE FOR CNSTS)
C
      REWIND 90
C
      DO J=JSTA,JEND 
      DO I=1,IMO
        RESO(I,J)=1./RESO(I,J)
      ENDDO
      ENDDO
C
      II=IMO/2
      JJ=JMO/2
C
      if(jj.gt.jsta.and.jj.le.jend)then
       print*,'i,j= ',ii,jj
       print*,'pdo= ',pdo(ii,jj)
       print*,'RESO= ',reso(ii,jj)
       print*,'fiso=',fiso(ii,jj)
       print*,'to= ',to(ii,jj,20)
       print*,'qo= ',qo(ii,jj,20)
       print*,'uo= ',uo(ii,jj,20)
       print*,'vo= ',vo(ii,jj,20)
       print*,'sno= ',sno(ii,jj)
       print*,'si= ',si(ii,jj)
       print*,'albedo= ',albedo(ii,jj)
       print*,'stc= ',stc(ii,jj,1)
       print*,'smc= ',smc(ii,jj,1)
      end if
C
      IF(MYPE.EQ.0)WRITE(NFCSTO) RUN,IDAT,IHRST,NTSD,LABEL
      if(mype.eq.0)print *," output date = ",idat,ihrst
C
      IF(MYPE.EQ.0)WRITE(NFCSTO) DUM2DOUT,DUM2DOUT
C
      DO L=1,LMO          
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO
      if(mype.eq.0)write(list,*)'  read  ',label,idat,ihrst
C
      IF(MYPE.EQ.0)WRITE(NFCSTO)RUN,IDAT,IHRST,NTSD,LABEL,
     1                          FIRST,IOUT,NSHDE
      if(mype.eq.0)then
        write(0,*)' INTRST before write'
        write(0,*)' pdo=',(pdo(87,j),j=41,45)
        write(0,*)' fiso=',(fiso(87,j),j=41,45)
      endif
C
      CALL COLLECT(PDO)
      CALL COLLECT(FISO)
      CALL COLLECT(RESO)
C
      if(mype.eq.0)then
        do j=1,jmo
        do i=1,imo+mod(j,2)-1
          if(pdo(i,j).lt.0.1)print*,'enormal pdo',i,j,pdo(i,j)
        enddo
        enddo
      endif
C
      IF(MYPE.EQ.0)WRITE(NFCSTO)PDO,RESO,FISO
C
      if(mype.eq.0)then
        write(0,*)' INTRST after write'
        write(0,*)' pdo=',(pdo(87,j),j=41,45)
        write(0,*)' fiso=',(fiso(87,j),j=41,45)
      endif
C
      IF(MYPE.EQ.0)WRITE(NFCSTO)PDB,TB,QB,UB,VB
C
      DO L=1,LMO
        CALL COLLECT_LOC(TO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample t',l,DUM2DOUT(21,48)
C
        CALL COLLECT_LOC(QO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample q',l,DUM2DOUT(21,48)
C
        CALL COLLECT_LOC(UO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample u',l,DUM2DOUT(21,48)
C
        CALL COLLECT_LOC(VO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample v',l,DUM2DOUT(21,48)
C
        CALL COLLECT_LOC(Q2O(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample q2',l,DUM2DOUT(21,48)
C
        DUM2DOUT=0.0
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
C
        CALL COLLECT_LOC(CWMO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)print*,'sample cwm',l,DUM2DOUT(1,1)
C
        DUM2DOUT=0.0
        IF(MYPE.EQ.0)write(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
        IF(MYPE.EQ.0)write(NFCSTO)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO
C
      CALL COLLECT(RADIN)
      CALL COLLECT(RADOT)
      CALL COLLECT(TG)
      CALL COLLECT(Z0)
      CALL COLLECT(AKMS)
      CALL COLLECT(CZEN)
C
      IF(MYPE.EQ.0)WRITE(NFCSTO)RUN,IDAT,IHRST,NTSD,LABEL,
     1                          RADIN,RADOT,TG,Z0,AKMS,CZEN
C
C***  REINITIALIZE HBOT, HTOP
C
      DO J=JSTA,JEND
      DO I=1,IMO
        HBOT(I,J)=LMHO(I,J)  
        HTOP(I,J)=LMHO(I,J)
      ENDDO
      ENDDO 
C
      CALL COLLECT(AKHS)
      CALL COLLECT(THS)
      CALL COLLECT(QS)
      CALL COLLECT(TWBS)
      CALL COLLECT(QWBS) 
      CALL COLLECT(HBOT)
      CALL COLLECT(CFRACL)   
      IF(MYPE.EQ.0)WRITE(NFCSTO)AKHS,THS,QS,TWBS,QWBS,HBOT,CFRACL
C 
      CALL COLLECT(THZ0)
      CALL COLLECT(QZ0)
      CALL COLLECT(UZ0)
      CALL COLLECT(VZ0)
      CALL COLLECT(USTAR) 
      CALL COLLECT(CFRACM) 
      CALL COLLECT(HTOP)
      IF(MYPE.EQ.0)
     1 WRITE(NFCSTO)THZ0,QZ0,UZ0,VZ0,USTAR,HTOP,CFRACM
C
      CALL COLLECT(SNO)
      CALL COLLECT(SI)
c      call collect(WET)
      CALL COLLECT(CLDEFI)
      CALL COLLECT(RF)
      CALL COLLECT(PSLP) 
      CALL COLLECT(CUPPT) 
      CALL COLLECT(CFRACH)
      IF(MYPE.EQ.0)
     1 WRITE(NFCSTO)SNO,SI,CLDEFI,RF,PSLP,CUPPT,CFRACH	 
C
      CALL COLLECT(SNOWT)
      CALL COLLECT(SOILT)
      CALL COLLECT(SOILQ)
      CALL COLLECT(PCANPY)
      CALL COLLECT(SNOWTR) 
      CALL COLLECT(PCTSNO) 
      IF(MYPE.EQ.0)
     1 WRITE(NFCSTO) SNOWT,SOILT,SOILQ,PCANPY,SNOWTR,PCTSNO	 
C
      CALL COLLECT(SWNET)
      CALL COLLECT(ELWDWN)
      CALL COLLECT(CZMEAN)
      CALL COLLECT(SIGT4)
      IF(MYPE.EQ.0)WRITE(NFCSTO)SWNET,ELWDWN,CZMEAN,SIGT4
C
      CALL COLLECT(U00)
      CALL COLLECT(LC)
      CALL COLLECT(SR)       
      IF(MYPE.EQ.0)WRITE(NFCSTO)U00,ULOUT,LC,SR
C
      CALL COLLECT(PREC)
      CALL COLLECT(ACPREC)
      CALL COLLECT(ACCLIQ)
      CALL COLLECT(CUPREC)
      IF(MYPE.EQ.0)WRITE(NFCSTO)RUN,IDAT,IHRST,NTSD,LABEL,
     1                          PREC,ACPREC,ACCLIQ,CUPREC
C
      CALL COLLECT(ACFRCV)
      CALL COLLECT(NCFRCV)
      CALL COLLECT(ACFRST)
      CALL COLLECT(NCFRST) 
      IF(MYPE.EQ.0)WRITE(NFCSTO) ACFRCV,NCFRCV,ACFRST,NCFRST
C
      CALL COLLECT(ACSNOW)
      CALL COLLECT(ACSNOM)
      CALL COLLECT(SSROFF)
      call collect(BGROFF)
      IF(MYPE.EQ.0)WRITE(NFCSTO)ACSNOW,ACSNOM,SSROFF,BGROFF
C
      CALL COLLECT(SFCSHX)
      CALL COLLECT(SFCLHX)
      CALL COLLECT(SUBSHX)
      CALL COLLECT(SNOPCX)
      CALL COLLECT(SFCUVX)
      CALL COLLECT(SFCEVP)
      CALL COLLECT(POTEVP)
      IF(MYPE.EQ.0)WRITE(NFCSTO)SFCSHX,SFCLHX,SUBSHX,SNOPCX,
     1             SFCUVX,SFCEVP,POTEVP
C
      call COLLECT(ASWIN)
      CALL COLLECT(ASWOUT)
      CALL COLLECT(ASWTOA)
      CALL COLLECT(ALWIN)
      CALL COLLECT(ALWOUT)
      CALL COLLECT(ALWTOA)
      IF(MYPE.EQ.0)WRITE(NFCSTO)
     1              ASWIN,ASWOUT,ASWTOA,ALWIN,ALWOUT,ALWTOA
C
      IF(MYPE.EQ.0)WRITE(NFCSTO)ARDSW,ARDLW,ASRFC,AVRAIN,AVCNVC
C
      CALL COLLECT(TH10)
      CALL COLLECT(Q10)
      CALL COLLECT(U10)
      CALL COLLECT(V10)
      CALL COLLECT(TSHLTR)
      CALL COLLECT(QSHLTR)
      CALL COLLECT(PSHLTR)
      IF(MYPE.EQ.0)WRITE(NFCSTO)TH10,Q10,U10,V10,TSHLTR
     1,                         QSHLTR,PSHLTR
C
      DO N=1,NSOIL
        CALL COLLECT(SMC(1,1,N))
        CALL COLLECT(STC(1,1,N))
        CALL COLLECT(SH2O(1,1,N))
      ENDDO 
C
      CALL COLLECT(CMC)
      CALL COLLECT(ALBEDO)
C
      IF(MYPE.EQ.0)THEN
        WRITE(NFCSTO)SMC
        WRITE(NFCSTO)CMC
        WRITE(NFCSTO)STC
        WRITE(NFCSTO)SH2O
        WRITE(NFCSTO)ALBEDO
        if(mype.eq.0) then
        print*,'sample smc',smc(2,4,1),smc(2,4,2)
        print*,'sample stc',stc(2,4,1),stc(2,4,2)
        print*,'sample sh2o',sh2o(2,4,1),sh2o(2,4,2)
        print*,'sample alb',albedo(2,4)
        print*," done writing restrt file"
        endif
      ENDIF
C-----------------------------------------------------------------------
C
C***  NOW WRITE OUT INITIAL CONDITIONS FILE FOR THE
C***  START AT TM12 OR FOR A STATIC ANALYSIS
C
      NINICD = 53
      REWIND NINICD
C
      IF(MYPE.EQ.0)THEN
        WRITE(NINICD)RUN,IDAT,IHRST,NTSD
        WRITE(NINICD)PDO
        WRITE(NINICD)RESO
        WRITE(NINICD)FISO
      ENDIF
C
      DO L=1,LMO
        CALL COLLECT_LOC(UO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NINICD)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO 
C
      DO L=1,LMO
        CALL COLLECT_LOC(VO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NINICD)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO 
C
      DO L=1,LMO
        CALL COLLECT_LOC(TO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NINICD)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO 
C
      DO L=1,LMO
        CALL COLLECT_LOC(QO(1,JSTA,L),DUM2DOUT)
        IF(MYPE.EQ.0)WRITE(NINICD)((DUM2DOUT(I,J),I=1,IMO),J=1,JMO)
      ENDDO 
C
      IF(MYPE.EQ.0)THEN
        WRITE(NINICD)SI 
        WRITE(NINICD)SNO
        WRITE(NINICD)SMC
        WRITE(NINICD)CMC
        WRITE(NINICD)STC
        WRITE(NINICD)SH2O
        WRITE(NINICD)ALBEDO
      ENDIF
C
      DEALLOCATE(HTMO)
      DEALLOCATE(VTMO)
      DEALLOCATE(LMHO)
      DEALLOCATE(LMVO)
      DEALLOCATE(TO)
      DEALLOCATE(QO)
      DEALLOCATE(UO)
      DEALLOCATE(VO)
      DEALLOCATE(CWMO)
      DEALLOCATE(Q2O)
      if(mype.eq.0)print *," done writing nfc file"
C
      IF(MYPE.EQ.(NUM_PROCS-1))THEN
        CALL SUMMARY()
      ENDIF
C-----------------------------------------------------------------------
      CALL MPI_FINALIZE(IERR)
C-----------------------------------------------------------------------
      STOP
      END
