C
      SUBROUTINE LL2KIN (GLATD,GLOND,II,JJ,
     1            D2R,R2D,TPHER,TLMER,DPHER,DLMER,LIST)
C
      INCLUDE  "parmeta.resin"
      include "mpif.h"
      INCLUDE "MPI_PARM.comm"
C
      PARAMETER  (IMTI=2*IMI-1, JMTI=JMI/2+1)
C
        real(8) DLM1,DLM2,TLAT1,TLAT2,TLON1,TLON2,D1,D2,tlat
c	real(8) TLAT
C-----------------------------------------------------------------
C***
C***  CONVERT FROM GEODETIC TO TRANSFORMED COORDINATES (DEGREES)
C***
      GLAT=GLATD*D2R
      GLON=GLOND*D2R
      DPH=DPHER*D2R
      DLM=DLMER*D2R
      TPH0=TPHER*D2R
      TLM0=TLMER*D2R
C
      X=COS(TPH0)*COS(GLAT)*COS(GLON-TLM0)+SIN(TPH0)*SIN(GLAT)
      Y=-COS(GLAT)*SIN(GLON-TLM0)
      Z=COS(TPH0)*SIN(GLAT)-SIN(TPH0)*COS(GLAT)*COS(GLON-TLM0)
      TLAT=R2D*ATAN(Z/SQRT(X*X+Y*Y))
      TLON=R2D*ATAN(Y/X)
C
C.... WRITE(LIST,50)TLAT,TLON
C..50 FORMAT(' TRANSFORMED LATITUDE IS',F8.3
C....1,               4X,'LONGITUDE IS',F8.3)
C***
C***  FIND THE K VALUE OF THE NEAREST H POINT
C***
      ROW=TLAT/DPHER+JMTI
      COL=TLON/DLMER+IMI
      NROW=INT(ROW)
      NCOL=INT(COL)
      TLAT=TLAT*D2R
      TLON=TLON*D2R
C***
C***  FIRST CONSIDER THE SITUATION WHERE THE POINT X IS AT
C***
C***              V      H
C***
C***
C***                 X
C***              H      V
C***
      IF(MOD(NROW,2).EQ.1.AND.MOD(NCOL,2).EQ.1.OR.
     1    MOD(NROW,2).EQ.0.AND.MOD(NCOL,2).EQ.0)THEN
        TLAT1=(NROW-JMTI)*DPH
        TLAT2=TLAT1+DPH
        TLON1=(NCOL-IMI)*DLM
        TLON2=TLON1+DLM
        DLM1=TLON-TLON1
        DLM2=TLON-TLON2
c        D1=ACOS(COS(TLAT)*COS(TLAT1)*COS(DLM1)+SIN(TLAT)*SIN(TLAT1))
c        D2=ACOS(COS(TLAT)*COS(TLAT2)*COS(DLM2)+SIN(TLAT)*SIN(TLAT2))
      D1=DACOS(DCOS(TLAT)*DCOS(TLAT1)*DCOS(DLM1)+DSIN(TLAT)*DSIN(TLAT1))
      D2=DACOS(DCOS(TLAT)*DCOS(TLAT2)*DCOS(DLM2)+DSIN(TLAT)*DSIN(TLAT2))
        IF(D1.GT.D2)THEN
          NROW=NROW+1
          NCOL=NCOL+1
        ENDIF
C***
C***  NOW CONSIDER THE SITUATION WHERE THE POINT X IS AT
C***
C***              H      V
C***
C***
C***                 X
C***              V      H
C***
      ELSE
        TLAT1=(NROW+1-JMTI)*DPH
        TLAT2=TLAT1-DPH
        TLON1=(NCOL-IMI)*DLM
        TLON2=TLON1+DLM
        DLM1=TLON-TLON1
        DLM2=TLON-TLON2
c        D1=ACOS(COS(TLAT)*COS(TLAT1)*COS(DLM1)+SIN(TLAT)*SIN(TLAT1))
c        D2=ACOS(COS(TLAT)*COS(TLAT2)*COS(DLM2)+SIN(TLAT)*SIN(TLAT2))
      D1=DACOS(DCOS(TLAT)*DCOS(TLAT1)*DCOS(DLM1)+DSIN(TLAT)*DSIN(TLAT1))
      D2=DACOS(DCOS(TLAT)*DCOS(TLAT2)*DCOS(DLM2)+DSIN(TLAT)*DSIN(TLAT2))
        IF(D1.LT.D2)THEN
          NROW=NROW+1
        ELSE
          NCOL=NCOL+1
        ENDIF
      ENDIF
      JJ=NROW
      II=NCOL/2
      IF(MOD(JJ,2).EQ.1)II=II+1      
C***
C***  NOW WE CAN FIND THE K VALUE
C***
c      KROWS=((NROW-1)/2)*IMTI
c      IF(MOD(NROW,2).EQ.1)THEN
c        K=KROWS+(NCOL+1)/2
c      ELSE
c        K=KROWS+IMI+NCOL/2
c      ENDIF
C.... WRITE(6,100)K
C.100 FORMAT(' NEAREST HEIGHT POINT AT K=',I5)
C
      RETURN
      END
