      SUBROUTINE MPI_FIRST
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    MPI_FIRST   SET UP MESSGAE PASSING INFO
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SETS UP MESSAGE PASSING INFO
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C   01-01-03  T BLACK - MODIFIED FROM THE ETA POST-PROCESSOR
C
C USAGE:    CALL MPI_FIRST
C   INPUT ARGUMENT LIST:
C
C   OUTPUT ARGUMENT LIST:
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_INIT
C       MPI_COMM_SIZE
C       MPI_COMM_RANK
C       PARA_RANGE
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - MPI_PARM.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
C----------------------------------------------------------------------
      INCLUDE "parmeta.resout"
      PARAMETER(IM=IMO,JM=JMO)
      INCLUDE "mpif.h"
C----------------------------------------------------------------------
      INCLUDE "MPI_PARM.comm"
C----------------------------------------------------------------------
C
      INTEGER IERR
C
C----------------------------------------------------------------------
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUM_PROCS,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYPE,IERR)
C
      IF(MYPE.EQ.0)THEN
C       PRINT*,' NUM_PROCS = ',NUM_PROCS
      ENDIf
C
      IF(NUM_PROCS.GT.1024)THEN
        PRINT*, ' too many MPI tasks, max is 1024, stopping'
        CALL MPI_ABORT(MPI_COMM_WORLD,1,IERR)
        STOP
      ENDIF
C----------------------------------------------------------------------
C
C***  ERROR CHECK
C
      IF(NUM_PROCS.GT.JM/2)THEN
        PRINT*, ' too many MPI tasks, max is ',JM/2,' stopping'
        CALL MPI_ABORT(MPI_COMM_WORLD,1,IERR)
        STOP
      ENDIF
C----------------------------------------------------------------------
C
C***  GLOBAL LOOP RANGES
C
      CALL PARA_RANGE(1,JM,NUM_PROCS,MYPE,JSTA,JEND)
C
      JSTA_P =JSTA
      JSTA_P2=JSTA
      JSTA_ALL(MYPE)=JSTA
      JEND_M =JEND
      JEND_M2=JEND
      JEND_ALL(MYPE)=JEND
C
      IF(MYPE.EQ.0)THEN
        JSTA_P =2
        JSTA_P2=3
      ENDIF
C
      IF(MYPE.EQ.NUM_PROCS-1)THEN
        JEND_M =JM-1
        JEND_M2=JM-2
      ENDIF
C----------------------------------------------------------------------
      DO IPE=0,NUM_PROCS-1
        CALL MPI_BCAST(JSTA_ALL(IPE),1,MPI_INTEGER,IPE,
     1                 MPI_COMM_WORLD,IRTN)
      ENDDO
      DO IPE=0,NUM_PROCS-1
        CALL MPI_BCAST(JEND_ALL(IPE),1,MPI_INTEGER,IPE,
     1                 MPI_COMM_WORLD,IRTN)
      ENDDO
C----------------------------------------------------------------------
C
C***  NEIGHBORS
C
      IUP=MYPE+1
      IDN=MYPE-1
C
      IF(MYPE.EQ.0)THEN
        IDN=MPI_PROC_NULL
      ENDIF
C
      IF(MYPE.EQ.NUM_PROCS-1)THEN
        IUP=MPI_PROC_NULL
      ENDIF
C
c     print *, ' MYPE,NUM_PROCS = ',mype,num_procs
c     print *, ' MYPE,JSTA,JSTA_P,JSTA_P2 = ',mype,jsta,jsta_p,jsta_p2
c     print *, ' MYPE,JEND,JEND_M,JEND_M2 = ',mype,jend,jend_m,jend_m2
c     print *, ' MYPE,IUP,IDN = ',mype,iup,idn
C----------------------------------------------------------------------
C
C***  COUNTS, DISPS FOR GATHERV AND SCATTERV
C
      DO I=0,NUM_PROCS-1
        CALL PARA_RANGE(1,JM,NUM_PROCS,I,JSX,JEX) 
        ICNT(I)=(JEX-JSX+1)*IM
        IDSP(I)=(JSX-1)*IM
C
        IF(MYPE.EQ.0)THEN
C         PRINT*, ' i, icnt(i),idsp(i) = ',I,ICNT(I),IDSP(I)
        ENDIF
C
      ENDDO
C----------------------------------------------------------------------
C
C***  EXTRACTION LIMITS    
C
      JSTA_2L=MAX(JSTA-1,1)
      JEND_2U=MIN(JEND+1,JM)
C     PRINT*, ' mype, jsta_2l, jend_2u = ',MYPE,JSTA_2L,JEND_2U
C----------------------------------------------------------------------
C
      END
